// generated by CommonLibrary.cmake, do not edit.

/**
 * @file include/pression/data/version.h
 * Defines version macros and class for library PressionData.
 */

#ifndef PRESSIONDATA_VERSION_H
#define PRESSIONDATA_VERSION_H

#include <pression/data/api.h>
#include <string>

namespace pressiondata
{
    /** The current major version. */
#   define PRESSIONDATA_VERSION_MAJOR 2

    /** The current minor version. */
#   define PRESSIONDATA_VERSION_MINOR 0

    /** The current patch level. */
#   define PRESSIONDATA_VERSION_PATCH 0

    /** The current SCM revision. */
#   define PRESSIONDATA_VERSION_REVISION 0x0

    /** The current binary interface. */
#   define PRESSIONDATA_VERSION_ABI 3ull

    /** The current major.minor.version as a string. */
#   define PRESSIONDATA_VERSION_STRING \
    "2.0.0"

    /** The current major.minor.version.revision as a string. */
#   define PRESSIONDATA_REV_STRING \
    "2.0.0.0x0"

/** True if the current version is newer than the given one. */
#   define PRESSIONDATA_VERSION_GT( MAJOR, MINOR, PATCH )       \
    ( (PRESSIONDATA_VERSION_MAJOR>MAJOR) ||                     \
      (PRESSIONDATA_VERSION_MAJOR==MAJOR && (PRESSIONDATA_VERSION_MINOR>MINOR || \
          (PRESSIONDATA_VERSION_MINOR==MINOR && PRESSIONDATA_VERSION_PATCH>PATCH))))

/** True if the current version is equal or newer to the given. */
#   define PRESSIONDATA_VERSION_GE( MAJOR, MINOR, PATCH )       \
    ( (PRESSIONDATA_VERSION_MAJOR>MAJOR) ||                     \
      (PRESSIONDATA_VERSION_MAJOR==MAJOR && (PRESSIONDATA_VERSION_MINOR>MINOR || \
          (PRESSIONDATA_VERSION_MINOR==MINOR && PRESSIONDATA_VERSION_PATCH>=PATCH))))

/** True if the current version is older than the given one. */
#   define PRESSIONDATA_VERSION_LT( MAJOR, MINOR, PATCH )       \
    ( (PRESSIONDATA_VERSION_MAJOR<MAJOR) ||                     \
      (PRESSIONDATA_VERSION_MAJOR==MAJOR && (PRESSIONDATA_VERSION_MINOR<MINOR || \
          (PRESSIONDATA_VERSION_MINOR==MINOR && PRESSIONDATA_VERSION_PATCH<PATCH))))

/** True if the current version is older or equal to the given. */
#   define PRESSIONDATA_VERSION_LE( MAJOR, MINOR, PATCH )       \
    ( (PRESSIONDATA_VERSION_MAJOR<MAJOR) ||                     \
      (PRESSIONDATA_VERSION_MAJOR==MAJOR && (PRESSIONDATA_VERSION_MINOR<MINOR || \
        (PRESSIONDATA_VERSION_MINOR==MINOR && PRESSIONDATA_VERSION_PATCH<=PATCH))))

/** Information about the current PressionData version. */
class PRESSIONDATA_API Version
{
public:
    /** @return the current major version of PressionData. */
    static int getMajor();

    /** @return the current minor version of PressionData. */
    static int getMinor();

    /** @return the current patch level of PressionData. */
    static int getPatch();

    /** @return the current PressionData version (MM.mm.pp). */
    static std::string getString();

    /** @return the SCM revision. */
    static unsigned long long getRevision();

    /** @return the current binary interface version of PressionData. */
    static int getABI();

    /** @return the current PressionData version plus the git SHA hash (MM.mm.pp.rev). */
    static std::string getRevString();

    /**
     * Runtime check for ABI compatibility.
     *
     * Call from code using PressionData. Will fail if the executable
     * was compiled against a version incompatible with the runtime version.
     *
     * @return true if the link-time and compile-time DSO are compatible.
     */
    static bool check()
    {
        return getMajor()==PRESSIONDATA_VERSION_MAJOR &&
               getMinor()==PRESSIONDATA_VERSION_MINOR;
    }

    /** @return JSON schema describing this object. */
    static std::string getSchema()
    {
        return R"(
                {
                  "title": "Version",
                  "type": "object",
                  "description": "Version information of the running application",
                  "properties": {
                    "major": { "type": "integer" },
                    "minor": { "type": "integer" },
                    "patch": { "type": "integer" },
                    "abi": { "type": "integer" },
                    "revision": { "type": "string" }
                  }
               }
               )";
    }

    /** @return JSON-encoded data for this object. */
    static std::string toJSON()
    {
        return R"(
               {
                 "major": 2,
                 "minor": 0,
                 "patch": 0,
                 "abi": 3,
                 "revision": "0"
               }
               )";
    }
};

}

#endif
